#include "StdAfx.h"
#include ".\rectanglescripletletplugin.h"
#include "ScriptletConstant.h"
#include "RectangleShape.h"
#include "XMLUtil.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_RECTANGLE_NODE, CRectangleScripletletPlugin);
CRectangleScripletletPlugin::CRectangleScripletletPlugin(void)
{
}

CRectangleScripletletPlugin::~CRectangleScripletletPlugin(void)
{
}
BOOL CRectangleScripletletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CRectangleShape* pRectangle = reinterpret_cast<CRectangleShape*>(pTarget);
		if (pRectangle == NULL)
		{
			return FALSE;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;

		USES_CONVERSION;
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_BACKGROUND_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_BACKGROUND_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			COLORREF clrBack = XMLUtil::ColorFromString(szValue);
			pRectangle->SetBackground(clrBack);
		}
	}
	return bSuccess;
}
CComponent* CRectangleScripletletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CRectangleShape;
	return pComponent;
}